/***************************************************************************
 *   Copyright (C) 2007 by    *
 *      *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/


#include "okintck_sfel01_01.h"
#include <qtango.h>

#include <QDesktopWidget>
double resizeFactorX, resizeFactorY, resizeFactorM;

okintck_sfel01_01::okintck_sfel01_01(QWidget *parent) : QWidget(parent)
{
	QSettings settings("fermi", "acs");
	// load (or set) path for images
	if (settings.contains("imgpath")) {
		imgpath = settings.value("imgpath").toString();
		// cout << imgpath.toStdString() << endl;
	}
	else {
		settings.setValue("imgpath", "/runtime/fermi/share/images/acs");
		// settings.setValue("imgpath", "/home/zambonl/devel/qt/fermi/acs/img");
	}
	if (!imgpath.endsWith("/")) {
		imgpath = imgpath + "/";
	}
	// setup User Interface
	ui.setupUi(this);

	// init resize data structure
	w_buffer tmp_buffer;
	// init global container
	tmp_buffer.w = NULL;
	tmp_buffer.x = 0.0;
	tmp_buffer.y = 0.0;
	tmp_buffer.width = (double) this->width();
	tmp_buffer.height = (double) this->height();
	ws_buffer.push_back(tmp_buffer);
	// init all widgets
	foreach(QWidget *w, this->findChildren<QWidget *>()) {
		tmp_buffer.w = w;
		tmp_buffer.font = w->font();
		tmp_buffer.x = (double) w->x();
		tmp_buffer.y = (double) w->y();
		tmp_buffer.width = (double) w->width();
		tmp_buffer.height = (double) w->height();
		ws_buffer.push_back(tmp_buffer);
	}
	resizeFactorX = resizeFactorY = resizeFactorM = 1;
	QDesktopWidget mydesk;
	if ((mydesk.width()>100) && (this->height() > mydesk.height()-50)) this->resize(this->width()*(mydesk.height()-50)/this->height(), mydesk.height()-50);
	cout << "mydesk.height(): " << mydesk.height() << ", this->height(): " << this->height() << endl;
	cout << "resizeFactorX: " << resizeFactorX << ", resizeFactorY: " << resizeFactorY << ", resizeFactorM: " << resizeFactorM  << endl;

}

okintck_sfel01_01::~okintck_sfel01_01()
{
	exit(0);
}    

void okintck_sfel01_01::resizeEvent( QResizeEvent * event ) {
	foreach(w_buffer tmp_buffer, ws_buffer) {
		if (tmp_buffer.w==NULL) {
			resizeFactorX = this->width()/tmp_buffer.width;
			resizeFactorY = this->height()/tmp_buffer.height;
			resizeFactorM = resizeFactorX<resizeFactorY? resizeFactorX: resizeFactorY;
		}
		else {
			tmp_buffer.w->resize(tmp_buffer.width*resizeFactorX,tmp_buffer.height*resizeFactorY);
			tmp_buffer.w->move(tmp_buffer.x*resizeFactorX,tmp_buffer.y*resizeFactorY);
			// fonts require special treatment
			QFont font = tmp_buffer.font;
			font.setPointSizeF(font.pointSizeF()*resizeFactorM);
			tmp_buffer.w->setFont(font);
		}
	}
}

